<meta content="text/html; charset=UTF-8" http-equiv="Content-Type">
<meta name="keywords" content="disk encryption, security, transparent, AES, plausible deniability, virtual drive, Linux, MS Windows, portable, USB drive, partition">
<meta name="description" content="LibreCrypt: An Open-Source transparent encryption program for PCs. With this software, you can create one or more &quot;containers&quot; on your PC - which appear as disks, anything written to these disks is automatically encrypted before being stored on your hard drive.">

<meta name="author" content="Sarah Dean">
<meta name="copyright" content="Copyright 2004, 2005, 2006, 2007, 2008 Sarah Dean">

<TITLE>Command Line Interface</TITLE>

<link href="https://raw.githubusercontent.com/t-d-k/librecrypt/master/docs/styles_common.css" rel="stylesheet" type="text/css">


<link rel="shortcut icon" href="https://github.com/t-d-k/librecrypt/raw/master/src/Common/Common/images/DoxBox.ico" type="image/x-icon">

<SPAN CLASS="master_link">
[![LibreCrypt logo](https://github.com/t-d-k/librecrypt/raw/master/src/Common/Common/images/DoxBox128.png)](http://LibreCrypt.eu/)
</SPAN>

<SPAN CLASS="master_title">
_[LibreCrypt](http://LibreCrypt.eu/): Open-Source disk encryption for Windows_
</SPAN>
***

<SPAN class="tip">
The latest version of this document can be found at the [LibreCrypt project site](https://github.com/t-d-k/librecrypt)
</SPAN>

## Read the [getting started](getting_started.html) guide first.

## Documentation Index                               
                                                              
* [advanced topics](advanced_topics.html)
* [command line](command_line.html)
* [command line decryption utilities](command_line_decryption_utilities.html)
* [contact details](contact_details.html)
* [contents](contents.html)
* [credits](credits.html)
* [description](description.html)
* [download](download.html)
* [FAQ](FAQ.html)
* [fault reporting](fault_reporting.html)
* [getting started](getting_started.html)
* [glossary](glossary.html)
* [impact of kernel driver signing](impact_of_kernel_driver_signing.html)
* [index](index.html)
* [installation and upgrading](installation_and_upgrading.html)
* [installation and upgrading - PC](installation_and_upgrading__PC.html)
* [known bugs](known_bugs.html)
* [licence](licence.html)
* [Linux examples - cryptoloop](Linux_examples__cryptoloop.html)
* [Linux examples - dm-crypt](Linux_examples__dm-crypt.html)
* [Linux examples - LUKS](Linux_examples__LUKS.html)
* [Linux volumes](Linux_volumes.html)
* [notes](notes.html)
* [notes PC](notes_PC.html)
* [pkcs11 drivers](pkcs11_drivers.html)
* [pkcs11 support](pkcs11_support.html)
* [plausible deniability](plausible_deniability.html)
* [portable mode](portable_mode.html)
* [technical details](technical_details.html)
* [technical details - build notes](technical_details__build_notes.html)
* [technical details - creating a new hash cypher driver](technical_details__creating_a_new_hash_cypher_driver.html)
* [technical details - creating FreeOTFE volumes](technical_details__creating_FreeOTFE_volumes.html)
* [technical details - filename extensions](technical_details__filename_extensions.html)
* [technical details - FreeOTFE CDB layout](technical_details__FreeOTFE_CDB_layout.html)
* [technical details - FreeOTFE CDB layout format 1](technical_details__FreeOTFE_CDB_layout_format_1.html)
* [technical details - FreeOTFE CDB layout format 2](technical_details__FreeOTFE_CDB_layout_format_2.html)
* [technical details - FreeOTFE CDB layout format 3](technical_details__FreeOTFE_CDB_layout_format_3.html)
* [technical details - FreeOTFE CDB layout format 4](technical_details__FreeOTFE_CDB_layout_format_4.html)
* [technical details - FreeOTFE CDB layout format 5](technical_details__FreeOTFE_CDB_layout_format_5.html)
* [technical details - FreeOTFE volumes and keyfiles](technical_details__FreeOTFE_volumes_and_keyfiles.html)
* [technical details - mounting FreeOTFE volumes](technical_details__mounting_FreeOTFE_volumes.html)
* [technical details - partition encryption decryption](technical_details__partition_encryption_decryption.html)
* [technical details - registry entries](technical_details__registry_entries.html)
* [technical details - RNGs](technical_details__RNGs.html)
* [TODO list](TODO_list.html)
* [translations](translations.html)
* [uninstalling](uninstalling.html)
* [version history](version_history.html)
                                                          



























































